#!/bin/bash

WATCH_LIST="syslogd:syslog sshd:sshd sendmail:sendmail"
INIT_SCRIPTS=/etc/init.d
PID_DIR=/var/run
EMAIL="root@localhost"
LOG=/tmp/hostquard.log

echo "`date` log started" >$LOG

function maillog () {
	echo "`date` log ended" >>$LOG
	mail -s "`hostname`.`dnsdomainname` `date` log" $EMAIL <$LOG
}

function st_daemon () {
	local DAEMON=$1
	local FUNCTION=$2
	if [ -x ${INIT_SCRIPTS}/${DAEMON} ]; then
		${INIT_SCRIPTS}/${DAEMON} ${FUNCTION}
	fi
}

for CHECK in ${WATCH_LIST}; do
	DAEMON=${CHECK%:*}
	SCRIPT=${CHECK#*:}
	pstat ${DAEMON} 2>/dev/null 1>/dev/null
	if [ $? = 10 ]; then
		echo "`date` $DAEMON started" >>$LOG
		I=$(($I+1))
		st_daemon $DAEMON start
	elif [ $? = 11 ]; then
		echo "`date` pid-file removed and $DAEMON started">>$LOG
		I=$(($I+1))
		rm -f ${PID_DIR}/${DAEMON}.pid
		# Do a restart in case some childs are still alive
		st_daemon $DAEMON restart
	elif [ $? = 2 ]; then
		echo "`date` $DAEMON restarted" >>$LOG
		I=$(($I+1))
		st_daemon ${DAEMON} restart
	else
		echo "`date` $DAEMON ok" >>$LOG
		I=$(($I+1))
	fi
done

maillog

#END
